<template>
  <v-scroll-y-transition>
    <v-btn
      v-if="[BookingStatus.BOOKED, BookingStatus.ACTIVE].includes(booking.status)"
      variant="tonal"
      class="text-amber-600 flex-initial"
      size="small"
      icon="mdi-pencil"
      @click="isEditShown = true"
    />
  </v-scroll-y-transition>

  <v-dialog
    v-model="isEditShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-pencil-outline"
        headline="Изменение дат"
        subtitle="Прибыль от бронирования будет пересчитана"
      />

      <section class="pt-4">
        <FormRow label="Выберите конечную дату">
          <section class="relative">
            <PluginDatePicker
              v-model="updatedEndDate"
              :locale="{ id: 'ru', masks: { weekdays: 'WW' } }"
              :attributes="highlightAttributes"
              :disabled-dates="disabledDates"
              :min-date="minDate"
              :max-date="maxDate"
              mode="date"
              color="teal"
              class="w-full mt-2"
              is-required
              :initial-page="{
                month: dt.wrap(booking.startDate).month,
                year: dt.wrap(booking.startDate).year,
              }"
            />

            <v-overlay
              v-if="isLoading"
              :model-value="true"
              scrim="white"
              contained
              persistent
              class="flex items-center justify-center"
            >
              <v-progress-circular
                color="var(--tw-color-teal-600)"
                size="64"
                indeterminate
              />
            </v-overlay>
          </section>
        </FormRow>

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            @click="onEndDateUpdate"
          >
            Изменить
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="onEndDateUpdateCancel"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

import { HttpClient } from '@/http';
import { BookingStatus } from '@/declarations';
import { useDateTime } from '@/composables';

import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FormRow from '@/components/layout/FormRow.vue';

const props = defineProps<{ booking: IVerboseBooking }>();
const emit = defineEmits(['update']);

const dt = useDateTime();

const isEditShown = ref(false);
const isLoading = ref(false);
const updatedEndDate = ref(props.booking.endDate);

const disabledDates = ref<any[]>([]);
const highlightAttributes = ref<any[]>([]);

const maxDate = ref<Date | null>(new Date(props.booking.endDate));
const minDate = computed(() => {
  return dt.wrap(props.booking.startDate).plus({ days: 1 }).toJSDate();
});

const resetForm = () => {
  updatedEndDate.value = props.booking.endDate;
  disabledDates.value = [];
  highlightAttributes.value = [];
};

const setMaxDate = async () => {
  isLoading.value = true;

  const searchStart = dt.wrap(props.booking.endDate).startOf('day');
  const searchEnd = dt.wrap(props.booking.endDate).plus({ weeks: 1 }).endOf('day');
  const propertyId = props.booking.property.id;

  const searchRange = {
    start: encodeURIComponent(searchStart.toISO()!),
    end: encodeURIComponent(searchEnd.toISO()!),
  };

  const { data: { values: bookings } } = await HttpClient.get<IVerboseBooking[]>('/v1/bookings/range', {
    params: { ...searchRange, propertyId },
  });

  isLoading.value = false;

  const [closestBooking] = (bookings ?? [])
    .filter(booking => booking.id !== props.booking.id)
    .toReversed();

  maxDate.value = closestBooking
    ? dt.wrap(closestBooking.startDate).toJSDate()
    : null;
};

const setSelectedRange = ({ start, end }: { start: string, end: string }) => {
  highlightAttributes.value = [];

  highlightAttributes.value.push({
    key: 'originalRange',
    dates: { start, end },
    highlight: {
      start: {
        contentStyle: { color: props.booking.property.color },
        style: { borderColor: props.booking.property.color },
        fillMode: 'outline',
      },
      base: {
        contentStyle: { color: 'white', textShadow: '0 0 3px #555' },
        style: { backgroundColor: props.booking.property.color, opacity: 0.6 },
        fillMode: 'light',
      },
      end: {
        contentStyle: { color: props.booking.property.color },
        style: { borderColor: props.booking.property.color },
        fillMode: 'outline',
      },
    },
  });
};

const onEndDateUpdate = () => {
  isEditShown.value = false;

  emit('update', {
    endDate: dt.wrap(updatedEndDate.value).toISO(),
  });
};

const onEndDateUpdateCancel = () => {
  isEditShown.value = false;
  resetForm();
};

watch(isEditShown, isShown => {
  resetForm();

  if (!isShown) {
    return;
  }

  setSelectedRange({
    start: dt.wrap(props.booking.startDate).toISO()!,
    end: dt.wrap(props.booking.endDate).toISO()!,
  });

  setMaxDate();
});

watch(updatedEndDate, endDate => {
  setSelectedRange({
    start: dt.wrap(props.booking.startDate).toISO()!,
    end: dt.wrap(endDate).toISO()!,
  });
});
</script>